var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { action, computed, observable } from 'mobx';
let BooleanStore = /** @class */ (() => {
    class BooleanStore {
        constructor(value = undefined) {
            this.toggle = this.toggle.bind(this);
            this.setTrue = this.setTrue.bind(this);
            this.setFalse = this.setFalse.bind(this);
            this._value = value;
        }
        get undefined() {
            return this._value === undefined;
        }
        get true() {
            return this._value === true;
        }
        get false() {
            return this._value === false;
        }
        toggle() {
            if (this._value !== undefined) {
                this._value = !this._value;
            }
        }
        setTrue() {
            this._value = true;
        }
        setFalse() {
            this._value = false;
        }
        setUndefined() {
            this._value = undefined;
        }
    }
    __decorate([
        observable
    ], BooleanStore.prototype, "_value", void 0);
    __decorate([
        computed
    ], BooleanStore.prototype, "undefined", null);
    __decorate([
        computed
    ], BooleanStore.prototype, "true", null);
    __decorate([
        computed
    ], BooleanStore.prototype, "false", null);
    __decorate([
        action
    ], BooleanStore.prototype, "toggle", null);
    __decorate([
        action
    ], BooleanStore.prototype, "setTrue", null);
    __decorate([
        action
    ], BooleanStore.prototype, "setFalse", null);
    __decorate([
        action
    ], BooleanStore.prototype, "setUndefined", null);
    return BooleanStore;
})();
export { BooleanStore };
//# sourceMappingURL=BooleanStore.js.map