import { ObjectStoreOptions } from './ObjectStoreOptions';
export declare class ObjectStore<T extends Object, K extends keyof T = keyof T> {
    private _defaultValue;
    private _value;
    constructor(value?: T, options?: ObjectStoreOptions<T>);
    get value(): T;
    get isDefault(): boolean;
    set(value: T): void;
    reset(): void;
    change(key: K, value: T[K]): this;
}
