import { NumericStoreOptions } from './NumericStoreOptions';
export declare class NumericStore {
    private _value;
    private _defaultValue;
    constructor(value: number, options?: NumericStoreOptions);
    get value(): number;
    get isDefault(): boolean;
    get isNegative(): boolean;
    get isPositive(): boolean;
    get isZero(): boolean;
    add(value: number): this;
    subtract(value: number): this;
    multiply(value: number): this;
    divide(value: number): this;
    increment(): this;
    decrement(): this;
    set(value: number): this;
    reset(): this;
}
