import { OperationState } from './OperationState';
import { OperationStateType } from "./Types";
export declare class OperationStateStore {
    private _status;
    constructor();
    get status(): OperationState;
    get isIdle(): boolean;
    get isRunning(): boolean;
    get isPaused(): boolean;
    get isDone(): boolean;
    get isAborted(): boolean;
    get isFailed(): boolean;
    get isCompleted(): boolean;
    get isNotCompleted(): boolean;
    idle(): void;
    start(): void;
    pause(): void;
    done(): void;
    abort(): void;
    fail(): void;
    get current(): OperationStateType;
}
