export declare class StringStore {
    private _value;
    private readonly _defaultValue;
    constructor(value?: string);
    get isDefault(): boolean;
    get value(): string;
    concat(value: string): this;
    substr(from: number, length?: number): this;
    substring(start: number, end?: number): this;
    trim(): this;
    trimLeft(): this;
    trimRight(): this;
    toLowerCase(): this;
    toUpperCase(): this;
    set(value: string): this;
    reset(): this;
}
